// 'Abstract_optional.ts' file
interface Responsibility { /* ... */
}

export abstract class Individual {
    abstract responsibilities?(): Set<Responsibility>; // Abstract and optional...

    abstract isResponsible(responsibility: Responsibility): boolean;
}

export class Kid extends Individual {
    responsibilities: undefined; // Implementation allows 'Kid' to no longer be abstract...

    isResponsible(responsibility: Responsibility): boolean {
        return false; // 'false' in all cases: 'responsibility' is ignored...
    };

    // 'typeof this.isResponsible' does not work:
    isNotResponsible(responsibility: Responsibility): ReturnType<typeof Kid.prototype.isResponsible> {
        return !this.isResponsible(responsibility);
    };
}