// 'The_case_of_this.ts' file
interface Person {
    identities: Array<string>
    display?: Function
}

const person: Person = {
    identities: ["Barbier", "Franck", "Bab"],
    display: function (this: Person) { // Differently to JavaScript, TypeScript makes explicit the type of 'this' in the function...
        window.console.assert(person === this);
        this.identities.forEach(function (element) {
            window.alert(element);
        }.bind(this)); // This guarantees 'window.console.assert(person === this)'
    }
};

person.display();
